unit Upolbaz;

interface

uses Messages,WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Dbase3p;

type
  Tform_polaBazy = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    lista_pol: TListBox;
    edit_szukaj: TEdit;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure edit_szukajChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure lista_polDblClick(Sender: TObject);
    procedure edit_szukajKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    baza: tDBase3Plus;
    pelnaLista: tStringList;
    procedure SetNazwaPl(value:String);
    procedure WypelnijListePol;
    function GetPoleBazy:string;
  public
    { Public declarations }
    property NazwaPl:string write SetNazwaPl;
    property poleBazy:string read GetPoleBazy;
    procedure DajPolaBazy(lista:tStringList);
  end;

var
  form_polaBazy: Tform_polaBazy;

implementation
uses Dialogs,SysUtils;

{$R *.DFM}

procedure tform_polaBazy.SetNazwaPl;
var
  f: integer;
begin
  baza.fileName:=value;
  if baza.Open then
  begin
    pelnaLista.Clear;
    for f:=0 to baza.fields.count-1 do
      pelnaLista.Add(baza.fields.strings[f]);
    baza.Close;
    WypelnijListePol;
  end;
end;

procedure tform_polaBazy.WypelnijListePol;
var
  i,f: integer;
  txs: string[20];
begin
  i:=lista_pol.itemIndex;
  if i>=0 then
    i:=longint(lista_pol.items.objects[i]);
  lista_pol.Clear;
  txs:=AnsiUpperCase(edit_szukaj.text);
  for f:=0 to pelnaLista.count-1 do
    if (txs='') or (Pos(txs,pelnaLista.strings[f])>0) then
      lista_pol.items.AddObject(pelnaLista.strings[f],pointer(f));
  if i>=0 then
    for f:=0 to lista_pol.items.count-1 do
      if longint(lista_pol.items.objects[f])=i then
      begin
        lista_pol.itemIndex:=f;
        Break;
      end;
end;

procedure Tform_polaBazy.FormCreate(Sender: TObject);
begin
  baza:=tDBase3plus.Create;
  pelnaLista:=tStringList.Create;
  pelnaLista.sorted:=false;
end;

procedure Tform_polaBazy.FormDestroy(Sender: TObject);
begin
  pelnaLista.Free;
  baza.Free;
end;

procedure Tform_polaBazy.edit_szukajChange(Sender: TObject);
begin
  timer1.enabled:=true;
end;

procedure Tform_polaBazy.Timer1Timer(Sender: TObject);
begin
  timer1.enabled:=false;
  WypelnijListePol;
end;

function tform_polaBazy.GetPoleBazy;
begin
  if lista_pol.itemIndex>=0 then
    Result:=lista_pol.items.strings[lista_pol.itemIndex]
  else
    Result:='';
end;

procedure Tform_polaBazy.OKBtnClick(Sender: TObject);
begin
  if lista_pol.itemIndex<0 then
  begin
    MessageDlg('Wpierw wybierz z listy pole bazy danych',mtWarning,[mbOK],0);
    modalResult:=mrNone;
  end;
end;

procedure Tform_polaBazy.lista_polDblClick(Sender: TObject);
begin
  OKBtn.Click;
end;

procedure Tform_polaBazy.edit_szukajKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key in [vk_Up,vk_Down,vk_Next,vk_prior] then
  begin
    PostMessage(lista_pol.handle,wm_KeyDown,key,0);
    key:=0;
  end;
end;

procedure tform_polaBazy.DajPolaBazy;
begin
  if lista<>nil then
    lista.Assign(pelnaLista);
end;

end.
