unit Uwydrfor;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, StdCtrls, Buttons, UPowiaz, ExtCtrls, SterForm, 
  {$IFDEF WIN32} RxRename, JvCtrls, {$ELSE} RXCtrls{$ENDIF};

type
  Tform_wydrForm = class(TForm)
    GroupBox1: TGroupBox;
    listaPowiaz: TComboBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    listaDoWydr: TRxCheckListBox;
    Timer1: TTimer;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    SterFormIPS1: TSterFormIPS;
    Label1: TLabel;
    c_DrukujWstecz: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn2Click(Sender: TObject);
    procedure listaPowiazChange(Sender: TObject);
    procedure listaPowiazClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    powiaz: tPowiazania;
    procedure WypelnijListePowiaz;
    procedure Zapisz;
    procedure WczytajBaze;
    procedure UstawFormSerw;
  public
    { Public declarations }
  end;

var
  form_wydrForm: Tform_wydrForm;

implementation
uses IniFilEx,UDefwydr,UCBaza,DBase3p,UTxtRead;

{$R *.DFM}

procedure Tform_wydrForm.FormCreate(Sender: TObject);
var
  plIni: tIniFileEx;
begin
  powiaz:=tPowiazania.Create;
  plIni:=tIniFileEx.Create(DajNPlIni);
  powiaz.Nr:=plIni.ReadInteger('param','nrPowiaz',0);
  listaDoWydr.Sorted:=plIni.ReadInteger('param','sort',1)=1;
  plIni.Free;

  listaDoWydr.items.Clear;

  WypelnijListePowiaz;

  Timer1.enabled:=true;
end;

procedure tform_wydrForm.WypelnijListePowiaz;
var
  f: integer;
begin
  listaPowiaz.items.Clear;
  powiaz.DajListeNazw(listaPowiaz.items);
  for f:=0 to listaPowiaz.items.count-1 do
    if longint(listaPowiaz.items.objects[f])=powiaz.Nr then
    begin
      listaPowiaz.itemIndex:=f;
      Break;
    end;
end;

procedure Tform_wydrForm.FormDestroy(Sender: TObject);
begin
  powiaz.Free;
end;

procedure Tform_wydrForm.BitBtn1Click(Sender: TObject);
begin
  Application.CreateForm(tForm_DefWydr,form_DefWydr);
  form_DefWydr.powiazanie:=powiaz;
  if form_DefWydr.ShowModal=mrOK then
  begin
    WypelnijListePowiaz;
    timer1.enabled:=true;
  end;
  form_DefWydr.Free;
end;

procedure Tform_wydrForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Zapisz;
end;

procedure Tform_wydrForm.Zapisz;
var
  plIni: tInifileEx;
begin
  plIni:=tIniFileEx.Create(DajNPlIni);
  plIni.WriteInteger('param','nrPowiaz',powiaz.nr);
  plIni.Free;
end;

procedure Tform_wydrForm.BitBtn2Click(Sender: TObject);
var
  oldNr: integer;
begin
  oldNr:=powiaz.nr;
  powiaz.nr:=0;
  Application.CreateForm(tForm_DefWydr,form_DefWydr);
  form_DefWydr.powiazanie:=powiaz;
  if form_DefWydr.ShowModal=mrOK then
  begin
    WypelnijListePowiaz;
    timer1.enabled:=true;
  end else
    powiaz.nr:=oldNr;
  form_DefWydr.Free;
end;

procedure Tform_wydrForm.listaPowiazChange(Sender: TObject);
var
  nrPowiaz: integer;
begin
  nrPowiaz:=longint(listaPowiaz.items.objects[listaPowiaz.itemIndex]);
  if nrPowiaz<>powiaz.nr then
  begin
    timer1.enabled:=false;
    powiaz.nr:=nrPowiaz;
    timer1.enabled:=true;
  end;
end;

procedure Tform_wydrForm.listaPowiazClick(Sender: TObject);
begin
  listaPowiazChange(sender);
end;


procedure Tform_wydrForm.WczytajBaze;
var
  bazaDan: tCustomBaza;
  n: integer;
  tx: string;
begin
  Case powiaz.typBazy of
    0: TDBase3Plus(bazaDan):=tDBase3Plus.Create;
    1: TBazaTxt1(bazaDan):=tBazaTxt1.Create;
  end;
  listaDoWydr.items.Clear;
  bazaDan.FileName:=powiaz.nBazy;
  if bazaDan.Open then
  begin
    n:=0;
    bazaDan.GotoStart;
    While not bazaDan.bazaEOF do
    begin
      tx:='';
      if powiaz.nPola1<>'' then
        tx:=tx+bazaDan.wart[powiaz.nPola1];
      if powiaz.nPola2<>'' then
        tx:=tx+' '+bazaDan.wart[powiaz.nPola2];
      if powiaz.nPola3<>'' then
        tx:=tx+' '+bazaDan.wart[powiaz.nPola3];
      tx:=powiaz.Nawin(tx);
      listaDoWydr.items.AddObject(tx,pointer(bazaDan.numerRekordu));
      bazaDan.GotoNext;
      Inc(n);
      if n mod 50=0 then
        Yield;
    end;
  end;
  bazaDan.Free;
end;

procedure Tform_wydrForm.Timer1Timer(Sender: TObject);
begin
  timer1.enabled:=false;
  WczytajBaze;
end;

procedure Tform_wydrForm.BitBtn3Click(Sender: TObject);
var
  ileZaz,f: integer;
begin
  ileZaz:=0;
  for f:=0 to listaDowydr.items.count-1 do
    if listaDowydr.checked[f] then
      Inc(ileZaz);
  if ileZaz>listaDowydr.items.count div 2 then
  begin
    for f:=0 to listaDowydr.items.count-1 do
      listaDowydr.checked[f]:=false;
  end else
    for f:=0 to listaDowydr.items.count-1 do
      listaDowydr.checked[f]:=true;
end;

procedure Tform_wydrForm.BitBtn4Click(Sender: TObject);
begin
  Close;
end;

procedure Tform_wydrForm.BitBtn6Click(Sender: TObject);
var
  f: integer;
  bazaDan: tCustomBaza;
  wartosc,tx,nPola: String;

  function DajNastepnePole(var tx:String):String;
  var
    p: Byte;
  begin
    Result:=tx;
    p:=Pos('+',tx);
    if p>0 then
    begin
      Result:=Copy(tx,1,p-1);
      Delete(tx,1,p);
    end else
      tx:='';
  end;

begin
  if listaDoWydr.itemIndex<0 then
  begin
    MessageDlg('Prosz wybra rekord w spisie !',mtInformation,[mbOK],0);
    Exit;
  end;
  sterFormIPS1.active:=false;
  UstawFormSerw;
  sterFormIPS1.symbol:=powiaz.symbol;
  sterFormIPS1.Identyfikator:=
    powiaz.symbol+'_'+InttoStr(listadoWydr.itemIndex)+'_'+listadoWydr.items.strings[listadoWydr.itemIndex];
  sterFormIPS1.active:=true;
  sterFormIPS1.caption:=listadoWydr.items.strings[listadoWydr.itemIndex];
  sterFormIPS1.calculate:=powiaz.przeliczaj;
  sterFormIPS1.autoformat:=true;
  Case powiaz.typBazy of
    0: TDBase3Plus(bazaDan):=tDBase3Plus.Create;
    1: TBazaTxt1(bazaDan):=tBazaTxt1.Create;
  end;
  try
    bazaDan.FileName:=powiaz.nBazy;
    if bazaDan.Open then
      With sterFormIPS1,sterFormIPS1.Fields do
      begin
        bazaDan.Seek(longint(listaDoWydr.items.objects[listadowydr.itemIndex]));
        Clear;
        for f:=1 to powiaz.ilePowiazan do
        begin
          tx:=powiaz.nPolaBazy[f];
          wartosc:='';
          nPola:=DajNastepnePole(tx);
          While nPola<>'' do
          begin
            if bazaDan.CzyJestPole(nPola) then
              wartosc:=wartosc+powiaz.NaWin(bazaDan.wart[nPola])
            else
              wartosc:=wartosc+nPola;
            nPola:=DajNastepnePole(tx);
          end;
          Add('p'+powiaz.nPolaformul[f]+'='+wartosc);
        end;
        SendData(true);
        ClearChange;
        ShowModal;
      end;
  finally
    bazaDan.Free;
  end;
end;

procedure Tform_wydrForm.BitBtn5Click(Sender: TObject);
var
  f,g,nrDruk: integer;
  bazaDan: tCustomBaza;
  pierwszy: boolean;
  tx,wartosc,nPola: String;

  function DajNastepnePole(var tx:String):String;
  var
    p: Byte;
  begin
    Result:=tx;
    p:=Pos('+',tx);
    if p>0 then
    begin
      Result:=Copy(tx,1,p-1);
      Delete(tx,1,p);
    end else
      tx:='';
  end;
begin
  Case powiaz.typBazy of
    0: TDBase3Plus(bazaDan):=tDBase3Plus.Create;
    1: TBazaTxt1(bazaDan):=tBazaTxt1.Create;
  end;
  try
    bazaDan.FileName:=powiaz.nBazy;
    if bazaDan.Open then
    begin
      pierwszy:=true;
      sterFormIPS1.Active:=false;
      UstawFormSerw;
      sterFormIPS1.symbol:=powiaz.symbol;
      sterFormIPS1.Active:=true;
      sterFormIPS1.calculate:=powiaz.przeliczaj;
      sterFormIPS1.autoformat:=true;

      if c_drukujWstecz.Checked then
        nrDruk:=listadoWydr.items.count-1
      else
        nrDruk:=0;
      for g:=0 to listadoWydr.items.count-1 do
      begin
        if listaDoWydr.checked[nrDruk] then
        begin
          bazaDan.Seek(longint(listaDoWydr.items.objects[nrDruk]));
          sterFormIPS1.caption:=listaDoWydr.items.strings[nrDruk];
          With sterFormIPS1,sterFormIPS1.Fields do
          begin
            Clear;
            for f:=1 to powiaz.ilePowiazan do
            begin
              tx:=powiaz.nPolaBazy[f];
              wartosc:='';
              nPola:=DajNastepnePole(tx);
              While nPola<>'' do
              begin
                if bazaDan.CzyJestPole(nPola) then
                  wartosc:=wartosc+powiaz.NaWin(bazaDan.wart[nPola])
                else
                  wartosc:=wartosc+nPola;
                nPola:=DajNastepnePole(tx);
              end;
              Add('p'+powiaz.nPolaformul[f]+'='+wartosc);
              {if bazaDan.CzyJestPole(powiaz.nPolaBazy[f]) then
                Add('p'+powiaz.nPolaformul[f]+'='+powiaz.NaWin(bazaDan.wart[powiaz.nPolaBazy[f]]))
              else
                Add('p'+powiaz.nPolaformul[f]+'='+powiaz.nPolaBazy[f]);}
            end;
            SendData(true);

            if pierwszy then
            begin
              if not ParamAndPrint then
                Break;
              pierwszy:=false;
            end else
              if not Print then
                Break;
          end;
        end;
        if c_drukujWstecz.Checked then
          Dec(nrDruk)
        else
          Inc(nrDruk);
      end;
    end;
  finally
    bazaDan.Free;
  end;
end;

procedure Tform_wydrForm.UstawFormSerw;
begin
  if FileExists(ExtractFilePath(Application.ExeName)+'formlic.exe') or
     FileExists(ExtractFilePath(Application.ExeName)+'formserw.exe') then
    SterFormIPS1.SerwerPath:=ExtractFilePath(Application.ExeName)
  else
    SterFormIPS1.SerwerPath:='';
end;

procedure Tform_wydrForm.Button1Click(Sender: TObject);
var
  f: integer;
  bazaDan: tCustomBaza;
begin
  if listaDoWydr.itemIndex<0 then
  begin
    MessageDlg('Prosz wybra rekord w spisie !',mtInformation,[mbOK],0);
    Exit;
  end;
  sterFormIPS1.active:=false;
  UstawFormSerw;

  sterFormIPS1.symbol:=powiaz.symbol;
  sterFormIPS1.active:=true;
  sterFormIPS1.caption:=listadoWydr.items.strings[listadoWydr.itemIndex];
  sterFormIPS1.calculate:=powiaz.przeliczaj;
  sterFormIPS1.autoformat:=true;
  Case powiaz.typBazy of
    0: TDBase3Plus(bazaDan):=tDBase3Plus.Create;
    1: TBazaTxt1(bazaDan):=tBazaTxt1.Create;
  end;
  try
    bazaDan.FileName:=powiaz.nBazy;
    if bazaDan.Open then
      With sterFormIPS1,sterFormIPS1.Fields do
      begin
        bazaDan.Seek(longint(listaDoWydr.items.objects[listadowydr.itemIndex]));
        Clear;
        for f:=1 to powiaz.ilePowiazan do
          if bazaDan.CzyJestPole(powiaz.nPolaBazy[f]) then
            Add('p'+powiaz.nPolaformul[f]+'='+powiaz.NaWin(bazaDan.wart[powiaz.nPolaBazy[f]]))
          else
            Add('p'+powiaz.nPolaformul[f]+'='+powiaz.nPolaBazy[f]);
        SendData(true);
        {panel1.align:=alTop;
        ShowChild(panel1);}
      end;
  finally
    bazaDan.Free;
  end;
end;

initialization
  InitFormIPS;
end.
